# -*- Mode: Perl -*-

#
# Copyright (c) 2001, Bryan Jurish.  All rights reserved.
#
# This package is free software.  You may redistribute it
# and/or modify it under the same terms as Perl itself.
#

###############################################################
#
#      File: Data::FStructure.pm
#    Author: Bryan Jurish <jurish@ling.uni-potsdam.de>
#
# Description: Feature-structures for perl
#
###############################################################

package Data::FStructure;
# System modules
# 3rd party exstensions
use Class::ISA;
# user extension modules
use Data::FStructure::Safe;
use Data::FStructure::perldata;
use Data::FStructure::List;
use Data::FStructure::Array;
@ISA = qw(Data::FStructure::Safe
	  Data::FStructure::Array
	  Data::FStructure::List);

our $VERSION = 0.01;

###############################################################
# Initialization ... just check supers
###############################################################
sub initialize {
  my ($fs,$args) = @_;
  my $thiscode = $fs->can('initialize');
  my ($code);
  foreach (Class::ISA::super_path(ref($fs))) {
    next unless (($code = $_->can('initialize')) && $code ne $thiscode); # don't recurse
    &$code($fs,$args);
  }
  return $fs;
}

###############################################################
# Nothing else here, it's all inherited...
###############################################################


__END__
1;
