# -*- Mode: Perl -*-
# t/04_subsu.t -- test subsumption & equality predicates

$TEST_DIR = './t';
#use lib qw(../blib/lib); $TEST_DIR = '.'; # for debugging

# load what we'll need
use Data::FStructure;
use Data::FStructure::pretty;
do "$TEST_DIR/common.plt";

plan(test => 7);

# 1
isok('new',($fs1 = Data::FStructure->new->from_text('[=1 (true) arg: [ (false) arg: [=1 ]]]')));
# 2
isok('clone',($fs2 = $fs1->clone));

# 3
$fs1->rename_nodes($fs1->root,'igor');
isok('subsumes [clone+rename:yes]',$fs1->subsumes($fs2));
# 4
isok('is_equal [clone+rename:yes]',$fs1->is_equal($fs2));

# 5
$fs2->delta($fs2->root,'arg2',$fs2->delta($fs2->root,'arg'));
isok('subsumes [extended:yes]', $fs1->subsumes($fs2));
# 6
isok('subsumes [extended:no]', $fs2->subsumes($fs1));
# 7
isok('is_equal [extended:no]', $fs1->is_equal($fs2));


print "\n";
# end of t/04_subsu.t

