# -*- Mode: Perl -*-
# t/05_unif.t -- test unification

$TEST_DIR = './t';
#use lib qw(../blib/lib); $TEST_DIR = '.'; # for debugging

# load what we'll need
use Data::FStructure;
use Data::FStructure::pretty;
do "$TEST_DIR/common.plt";

plan(test => 4);

# prep
$fs1 = Data::FStructure->new->from_text('[=1 (foo) arg: [ arg: [=1 ]]]');
$fs2 = Data::FStructure->new->from_text('[=1 arg: [ =1 ]]');
$fs3 = Data::FStructure->new->from_text('[ (bar) arg: [ (baz) ] ]');

# 1
$fsu = $fs1->unify($fs2);
isok('unify [untyped:yes]',defined($fsu) && $fsu->as_string,'[ =1 (foo) arg: [ =1 ] ]');
# 2
isok('unify [untyped:no]',!defined($fs1->unify($fs3)));

# prep
$h = truth_hi();
$fs1 = Data::FStructure->new({hierarchy=>$h})->from_text('[=1 (maybe) arg: [ (maybenot) arg: [=1 ]]]');
$fs3 = Data::FStructure->new({hierarchy=>$h})->from_text('[ (whocares) ]');
# 3
$fsu = $fs1->unify($fs2);
isok('unify [typed:yes]', defined($fsu) && $fsu->as_string,'[=1 (whoknows) arg: [ =1 ] ]');
# 4
isok('unify [typed:no]', !defined($fs1->unify($fs3)));



print "\n";
# end of t/05_unif.t

