# -*- Mode: Perl -*-
# t/07_tied.t : test tied-hash interface

$TEST_DIR = './t';
#use lib qw(../blib/lib); $TEST_DIR = '.'; # for debugging

# load what we'll need
use Data::FStructure;
use Data::FStructure::Tied;
use Data::FStructure::pretty;
do "$TEST_DIR/common.plt";

plan(test => 15);

# 1
$h = {};
isok('tie',($fs = tie(%$h,Data::FStructure::TiedHash)));
# 2-3
isok('hash-set [depth=2]',$h->{syn}{cat} = 'verb');
isok('check',$fs->as_string,q([ syn: [ cat: [ (verb) ] ] ]));
# 4-5
isok('hash-set [depth=1/reuse_paths]',$h->{syn} = 'vsyn');
isok('check',$fs->as_string,q([ syn: [ (vsyn) cat: [ (verb) ] ] ]));

# 6-7
isok('hash-get [depth=1]', ($sub = $h->{syn}));
isok('check', tied(%$sub)->as_string, q([ (vsyn) cat: [ (verb) ] ]));

# 8-9
isok('automagic creation', ($sub = $h->{sem}));
isok('check', tied(%$h)->as_string, q([ sem: [ ] syn: [ (vsyn) cat: [ (verb) ] ] ]));

# 10-11
isok('substructure assignment', ($h->{sem} = $h->{syn}));
isok('check', tied(%$h)->as_string, q([ sem: [ =1 (vsyn) cat: [ =2 (verb) ] ] syn: [ =1 ] ]));

# 12-13
ulistok('keys', [keys(%$h)], [qw(syn sem)]);
ulistok('values',
	[map { tied(%$_)->as_string } values(%$h)],
	[q([ (vsyn) cat: [ (verb) ] ]),
	 q([ (vsyn) cat: [ (verb) ] ])]);


# 14-15
$hphon = {};
tie %$hphon, Data::FStructure::TiedHash;
$hphon->{phon}{pform} = '/mU/';
isok('unify [double-tied]', tied(%$hphon)->_unify(tied(%$h)));
isok('check',
     tied(%$hphon)->as_string,
     q([ phon: [ pform: [ (/mU/) ] ] sem: [ =1 (vsyn) cat: [ =2 (verb) ] ] syn: [ =1 ] ]));


print "\n";
# end of t/07_tied.t

